/*

Author: David Voswinkel
Email:  d.voswinkel@netcologne 
Date:   2003-07-27 16:43:09

o paralell port support by david voswinkel 
o ppdev support by  ucon64 team
     NoisyB (noisyb@gmx.net) 
     dbjh  

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

$Id: parport.c,v 1.5 2004/03/06 16:24:17 david Exp $

$Log: parport.c,v $
Revision 1.5  2004/03/06 16:24:17  david
o added ppdev support
o fixed endianess issuse of the bin file/bin arrays
o ported io to ucon io lib

Revision 1.4  2003/11/22 12:18:32  david
added switch for parport_delay loop

Revision 1.3  2003/07/27 17:24:10  david
added read cart

Revision 1.2  2003/07/27 14:28:51  david
*** empty log message ***

*/


#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/io.h>
#include <sys/timeb.h>
#include <sys/time.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <linux/ppdev.h>
#include <linux/parport.h>


#include "parport.h"

extern unsigned char img_mbilinker[];
extern unsigned char img_logo[];
extern unsigned char img_loader[];
static int parport_send_head(int cmd,int size);
static int parport_debug = 0;

static int f2a_pport;
static int f2a_pport_fd;    
static const char * f2a_ppdev = "/dev/parport0";
static MODE_T  f2a_mode = PARPORT;
static IO_DIRECTION_T  f2a_io_direction = FORWARD;

static int f2a_io_mode;


static int parport_send_buffer(int cmd,int addr,
                            int size,unsigned  char * resource,int head,int flip,unsigned int exec,int mode);

static int parport_send_cmd(int cmd,int addr, int size);
static int parport_exec_cmd(int cmd,int addr, int size);
static int parport_receive_data(int cmd,int addr, int size,unsigned char * filename, int flip);

static int parport_send_head(int cmd,int size);
static int parport_send_raw(unsigned char * buffer, int len);
static int parport_receive_raw(unsigned char * buffer, int len);
static int parport_wait();
static void parport_out31 (unsigned char val);
static void parport_out91 (unsigned char val);
static void parport_nop();
static int parport_init_delay(int target);
static unsigned int parport_flip(unsigned int val);
static int parport_open(int port);
static unsigned char inportb (unsigned short port);
static void outportb (unsigned short port, unsigned char byte);
static int parport_nop_cnt;


const unsigned char parport_gba_header[] = {
            0xea, 0x00, 0x00, 0x2e, 0x51, 0xae, 0xff, 0x24, 0x21, 0xa2, 0x9a, 0x69, 0x0a, 0x82, 0x84, 0x3d,
            0xad, 0x09, 0xe4, 0x84, 0x98, 0x8b, 0x24, 0x11, 0x21, 0x7f, 0x81, 0xc0, 0x19, 0xbe, 0x52, 0xa3,
            0x20, 0xce, 0x09, 0x93, 0x4a, 0x4a, 0x46, 0x10, 0xec, 0x31, 0x27, 0xf8, 0x33, 0xe8, 0xc7, 0x58,
            0xbf, 0xce, 0xe3, 0x82, 0x94, 0xdf, 0xf4, 0x85, 0xc1, 0x09, 0x4b, 0xce, 0xc0, 0x8a, 0x56, 0x94,
            0xfc, 0xa7, 0x72, 0x13, 0x73, 0x4d, 0x84, 0x9f, 0x61, 0x9a, 0xca, 0xa3, 0x27, 0xa3, 0x97, 0x58,
            0x76, 0x98, 0x03, 0xfc, 0x61, 0xc7, 0x1d, 0x23, 0x56, 0xae, 0x04, 0x03, 0x00, 0x84, 0x38, 0xbf,
            0xfd, 0x0e, 0xa7, 0x40, 0x03, 0xfe, 0x52, 0xff, 0xf1, 0x30, 0x95, 0x6f, 0x85, 0xc0, 0xfb, 0x97,
            0x25, 0x80, 0xd6, 0x60, 0x03, 0xbe, 0x63, 0xa9, 0xe2, 0x38, 0x4e, 0x01, 0xff, 0x34, 0xa2, 0xf9,
            0x44, 0x03, 0x3e, 0xbb, 0xcb, 0x90, 0x00, 0x78, 0x94, 0x3a, 0x11, 0x88, 0x63, 0x7c, 0xc0, 0x65,
            0xaf, 0x3c, 0xf0, 0x87, 0x8b, 0xe4, 0x25, 0xd6, 0x72, 0xac, 0x0a, 0x38, 0x07, 0xf8, 0xd4, 0x21,
};

const unsigned char header[] = 	{ 	0x49,0x2d,0x4c,0x69,0x6e,0x6b,0x65,0x72,
                                        0x2e,0x31,0x30,0x30,0x00,0x00,0x01,0xe8};
void parport_enable_debug()
{
    parport_debug++;
}

static const char * parport_mode_str ( int mode ) 
{
    switch (mode){
        case PPDEV:
            return "PPDEV";
        case PARPORT:
            return "PARPORT";
        default:
            return "UNKONW";
    }
    return "UNKOWN";
}

int parport_init(DEVICE_T device,int target_delay)
{

    if (DEVICE_PARPORT ==  device) { 
        f2a_mode = 0 ; //PARPORT;
        f2a_pport = 0x378;

    } else if (DEVICE_PPDEV == device) {
        f2a_mode = 1 ;//PPDEV;
        f2a_pport = 0;
    }
    
    
    fprintf(stderr,"Device mode '%s'\n",parport_mode_str(f2a_mode));
    fprintf(stderr, "Using Base port 0x%-4x \n",f2a_pport);
    fprintf(stderr, "Rendering delay loop counter... ");
    parport_nop_cnt = parport_init_delay(target_delay);
    fprintf(stderr,"done(%i)\n",parport_nop_cnt);
    fprintf(stderr,"Opening Device...");
    parport_open(f2a_pport);
    fprintf(stderr,"done\n");
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x04);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_DATA), 0x04);
    parport_out91 (0x47);
    parport_out31 (0x02);
    parport_out91 (0x12);
    parport_out31 (0x01);
    parport_out91 (0x34);
    parport_out31 (0x00);
    parport_out91 (0x56);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x03);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_DATA), 0x02);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x09);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x00);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x00);
    
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x00);
    outportb ((unsigned short) (f2a_pport + PARPORT_EDATA), 0x34);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_EADDRESS), 0x00);
    outportb ((unsigned short) (f2a_pport + PARPORT_EDATA), 0x56);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x02);
    inportb  ((unsigned short) (f2a_pport + PARPORT_STATUS));
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x06);
    inportb  ((unsigned short) (f2a_pport + PARPORT_STATUS));
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x00);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_EADDRESS), 0x04);
    outportb ((unsigned short) (f2a_pport + PARPORT_EDATA), 0x07);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_EADDRESS), 0x02);
    outportb ((unsigned short) (f2a_pport + PARPORT_EDATA), 0x12);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_EADDRESS), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_EDATA), 0x34);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_EADDRESS), 0x00);
    outportb ((unsigned short) (f2a_pport + PARPORT_EDATA), 0x56);
    
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
    outportb ((unsigned short) (f2a_pport + PARPORT_EADDRESS), 0x02);
    outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x00);
    fprintf(stderr,"Init done.\n");
  
    return 0;
}   

int parport_boot(int upload_logo)
{
    unsigned char recv[4];
    fprintf(stderr,"Tyring to bring GBA into mulitboot state.\n");
    if (parport_send_head(PP_HEAD_BOOT,1))
        return -1;

    if (parport_receive_raw(recv,4))
        return -1;
    if (upload_logo){
        if (parport_send_buffer(PP_CMD_WRITEDATA,LOGO_ADDR,LOGO_SIZE,img_logo,0,0,0,0))
            return -1;
    }
    fprintf(stdout,"Uploading iLinker Client.\n");
    if (parport_send_buffer(PP_CMD_WRITEDATA,EXEC_STUB,BOOT_SIZE,img_mbilinker,HEAD,FLIP,EXEC,0)){
        fprintf(stdout,"Upload failed.\n");
        return -1;
    }
    return 0;

}


int parport_write(int files_cnt,char ** files,unsigned int addr)
{
    int j;
    struct stat st;
    int size;
   printf("ok..\n");
    if (files_cnt>1){
        fprintf(stdout,"Uploading Multiloader.\n");
        if(parport_send_buffer(PP_CMD_WRITEROM,addr,LOADER_SIZE,img_loader,HEAD,FLIP,0,0))
            return -1;
        addr+=LOADER_SIZE;
    }
    for(j=0; j<files_cnt; j++){
        if(stat(files[j],&st)==-1){
            perror("failed to stat file");
            return -1;
        }
        size=st.st_size;
        if(size & (32768-1)) size+=32768;
        size&=~(32768-1);
        fprintf(stdout,"Uploading %s %i Kbytes, padded to %i Kbytes.\n", files[j],(int)(st.st_size/1024),(int)(size/1024));
        if (parport_send_buffer(PP_CMD_WRITEROM,addr,size,files[j],HEAD,FLIP,0,1))
            return -1;

        addr+=size;
    }
    return 0;
}

int parport_erase(unsigned int start,unsigned int size )
{
    int end,addr;
    parport_exec_cmd(PP_CMD_READDATA,ERASE_STUB,1024);
    end = start + (size);

    fprintf(stdout,"Erase Cart start=0x%08x end=0x%08x \n",start,end);
    for (addr=start; addr < end ;addr+=0x40000){
        parport_send_cmd(PP_CMD_ERASE,addr,1024);
    }
    return 0;
}


int parport_read(unsigned int start,unsigned int size, unsigned char * filename )
{
    parport_exec_cmd(PP_CMD_READDATA,ERASE_STUB,1024);
    fprintf(stdout,"Reading from Cart start=0x%08x size=0x%08x \n",start,size);
    parport_receive_data(PP_CMD_READDATA,start,size,filename,FLIP);
    return 0;
}



static int parport_send_head(int cmd, int size)
{
    unsigned char trans[] = {0xa,0x8,0xe,0xc,0x2,0x0,0x6,0x4};
    parport_msg_head_t msg_head;
    memset(&msg_head, 0, sizeof(parport_msg_head_t));
    memcpy(&msg_head.head, header,16);
    msg_head.cmd = cmd;
    msg_head.size = (size/1024)&0xffff;
    msg_head.unkown = (trans[((msg_head.size&255)/32)] << 4 ) | (((1023 - (msg_head.size&1023) ) / 256)&0x0f);
    //msg_head.unkown=0x82;
    if (parport_send_raw((unsigned char*)&msg_head,sizeof(parport_msg_head_t)))
        return -1;
    return 0;
}


static int parport_exec_cmd(int cmd,int addr, int size)
{
    unsigned char *buffer;
    parport_msg_cmd_t msg_cmd;
    memset(&msg_cmd, 0, sizeof(parport_msg_cmd_t));
    msg_cmd.magic = parport_flip(PP_MAGIC_NUMBER);
    msg_cmd.cmd = parport_flip(cmd);
    msg_cmd.addr = parport_flip(addr);
    msg_cmd.sizekb = parport_flip(size/1024);

    msg_cmd.exec_stub = parport_flip(EXEC_STUB);
    msg_cmd.exec = parport_flip(0x08);
    parport_send_head(PP_HEAD_READ,size);
    parport_wait();

    if (parport_debug)
        fprintf (stderr, "sending msg_cmd cmd='0x%08x' addr='0x%08x' size='0x%08x' %i bytes\n",
        msg_cmd.cmd,msg_cmd.addr,msg_cmd.sizekb, sizeof(parport_msg_cmd_t) );


    parport_send_raw((unsigned char*)&msg_cmd,sizeof(parport_msg_cmd_t));
    //parport_wait();
    buffer = (unsigned char *) malloc(size * sizeof(unsigned char));
    if (NULL==buffer){
        fprintf(stderr,"malloc failed\n");
        return -1;
    }
    parport_receive_raw(buffer,size);;

    return 0;
}

static int parport_receive_data(int cmd,int addr, int size,unsigned char * filename, int flip)
{
    unsigned char recv[4];
    unsigned char buffer[1024];
    unsigned char *mbuffer;

    int romf=-1;
    int i,j,n;
    int *ptr;
    int progress;
    parport_msg_cmd_t msg_cmd;
    memset(&msg_cmd, 0, sizeof(parport_msg_cmd_t));
    msg_cmd.magic = parport_flip(PP_MAGIC_NUMBER);
    msg_cmd.cmd = parport_flip(cmd);
    msg_cmd.addr = parport_flip(addr);
    msg_cmd.sizekb = parport_flip(size/1024);

    if (parport_send_head(PP_HEAD_READ,size))
        return -1;

    if (parport_receive_raw(recv,4))
        return -1;

    if (parport_debug)
        fprintf (stderr, "sending msg_cmd cmd='0x%08x' addr='0x%08x' size='0x%08x' %i bytes\n",
        msg_cmd.cmd,msg_cmd.addr,msg_cmd.sizekb, sizeof(parport_msg_cmd_t) );

    parport_send_raw((unsigned char*)&msg_cmd,sizeof(parport_msg_cmd_t));

    romf=open(filename, O_WRONLY|O_CREAT,0666);


#if 1
    if(romf==-1){
            perror("unable to open rom.");
            return -1;
    }
    mbuffer = (unsigned char *) malloc(size*sizeof(unsigned char));
    parport_receive_raw(mbuffer,size);
    if (flip){
        ptr = (int *) mbuffer;
        for (j=0;j<size/4;j++)
            ptr[j] = parport_flip(ptr[j]);
    }
    //memcpy(buffer,parport_gba_header,HEAD_SIZE);
    if(write(romf, mbuffer, size)==-1){
            perror("unable to write data to file");
            close(romf);
            return -1;
    }
    close(romf);
#else
    for (i=0;i<size;i+=1024){
        parport_receive_raw(buffer,1024);;
        if (flip){
            ptr = (int *) buffer;
            for (j=0;j<256;j++)
                ptr[j] = parport_flip(ptr[j]);
        }

        if(write(romf, buffer, 1024)==-1)
        {
            perror("unable to write data to file");
            close(romf);
            return -1;
        }

        if (parport_debug){
            fprintf (stderr, "reading %i.chunk of %i\n", (int)(i/1024)+1, (int)(size/1024));
        } else {
            progress = (int) ((100.0/size) * (i+(1024)));
            fprintf (stdout,"\r[");
                for (n=0;n<=100;n++)
                if (n<=progress)
                    fprintf (stdout,"=");
                else
                    fprintf (stdout," ");
            fprintf (stdout,"]\r");
            fflush(stdout);
        }
    }
    if (!parport_debug)
        fprintf (stdout,"\n");
    close(romf);
#endif

    return 0;
}


static int parport_send_cmd(int cmd,int addr,int size)
{
    unsigned char recv[4];
    parport_msg_cmd_t msg_cmd;
    memset(&msg_cmd, 0, sizeof(parport_msg_cmd_t));
    msg_cmd.magic = parport_flip(PP_MAGIC_NUMBER);
    msg_cmd.cmd = parport_flip(cmd);
    msg_cmd.addr = parport_flip(addr);
    msg_cmd.sizekb = parport_flip(size/1024);

    if (parport_send_head(PP_HEAD_WRITE,size))
        return -1;

    if (parport_receive_raw(recv,4))
        return -1;

    if (parport_debug)
        fprintf (stderr, "parport_send_cmd cmd='0x%08x' addr='0x%08x' size='0x%08x' %i bytes\n",
        msg_cmd.cmd,msg_cmd.addr,msg_cmd.sizekb, sizeof(parport_msg_cmd_t) );

    if(parport_send_raw((unsigned char*)&msg_cmd,sizeof(parport_msg_cmd_t)))
        return -1;
    return 0;
}
static int parport_send_buffer(int cmd,int addr,
                            int size,unsigned  char *resource,int head,int flip,unsigned int exec,int mode)
{
    unsigned char recv[4];
    int i,j,n;
    int *ptr;
    int progress;
    unsigned char buffer[1024 ];
    int romf=-1;
    parport_msg_cmd_t msg_cmd;
    memset(&msg_cmd, 0, sizeof(parport_msg_cmd_t));
    msg_cmd.magic = parport_flip(PP_MAGIC_NUMBER);
    msg_cmd.cmd = parport_flip(cmd);
    msg_cmd.addr = parport_flip(addr);
    msg_cmd.sizekb = parport_flip(size/1024);
    if (exec){
        msg_cmd.exec_stub = parport_flip(EXEC_STUB);
        msg_cmd.exec =  parport_flip(0x08);
    }
    if (parport_send_head(PP_HEAD_WRITE,size))
        return -1;
    if (parport_receive_raw(recv,4))
        return -1;

    if (parport_debug)
        fprintf (stderr, "parport_send_buffer cmd='0x%08x' addr='0x%08x' size='0x%08x' %i bytes\n",
        msg_cmd.cmd,msg_cmd.addr,msg_cmd.sizekb, sizeof(parport_msg_cmd_t) );

    if(parport_send_raw((unsigned char*)&msg_cmd,sizeof(parport_msg_cmd_t)))
        return -1;

    if (1==mode){
        romf=open(resource,O_RDONLY);
        if(romf==-1){
            perror("unable to open rom.");
            return -1;
        }
    }

    for (i=0;i<size;i+=1024){
        if (1==mode){
            if(read(romf, buffer, 1024)==-1){
                perror("failed to read from file");
                return -1;
            }
        } else {
            memcpy(buffer,resource,1024);
        }
        if (flip){
            ptr = (int *) buffer;
            for (j=0;j<256;j++)
                ptr[j] = parport_flip(ptr[j]);
        }
        
        if (!i && head){
            memcpy(buffer,parport_gba_header,HEAD_SIZE);
        }
        
        if (parport_debug){
            fprintf (stderr, "sending %i.chunk of %i\n", (int)(i/1024)+1, (int)(size/1024));
        } else {
            progress = (int) ((100.0/size) * (i+1024));
            fprintf (stdout,"\r[");
                for (n=0;n<=100;n++)
                if (n<=progress)
                    fprintf (stdout,"=");
                else
                    fprintf (stdout," ");
            fprintf (stdout,"]\r");
            fflush(stdout);
        }
        parport_send_raw(buffer,1024);
        if (0==mode) resource+=1024;
    }
    if (!parport_debug)
        fprintf (stdout,"\n");
    if (1==mode)
        close(romf);
    return 0;
}

static void parport_dump_byte(unsigned char byte){
    char i;
    for (i=7; i>-1; i--){
        if ((byte>>i)&1)
            fprintf(stderr,"1");
        else
            fprintf(stderr,"0");
    }
    fprintf(stderr,"\n");
}


static int parport_receive_raw(unsigned char * buffer, int len){

    int err;
    int i;
    unsigned char *ptr;
    unsigned char nibble;
    struct timespec t;
    t.tv_sec = 0;
    t.tv_nsec = 1;
    ptr=buffer;
    *ptr='\0';
    if (parport_debug)
        fprintf(stderr, "\nreceive:\n%04x: ",0);

    for (err=0,i=0; i<len*2; i++){
        nibble = 0;
        outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL),0x04);
        parport_nop();
        while (inportb ((unsigned short) (f2a_pport + PARPORT_STATUS)) & PARPORT_IBUSY)  nanosleep(&t,NULL);
        outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL),0x05);
        nibble = inportb ((unsigned short) (f2a_pport + PARPORT_STATUS));
        parport_nop();
        while (!(inportb ((unsigned short) (f2a_pport + PARPORT_STATUS)) & PARPORT_IBUSY))  nanosleep(&t,NULL);
        if (i%2){
            *ptr |= (nibble>>3)&0x0f;
            if (parport_debug) {
                fprintf(stderr, "%02x ",(unsigned char)*ptr);
                if (!(((i/2)+1)%32) && i && (i/2)<len-1)
                    fprintf(stderr, "\n%04x: ",(i/2)+1);
            }
            ptr++;
           // *ptr='\0';
       } else {
            *ptr |= ((nibble>>3)&0xf)<<4;
        }
    }
    if (parport_debug)
        fprintf(stderr, "\n");

    return err;
}



static int parport_send_raw(unsigned char * buffer, int len)
{
    int timeout;
    int i;
    unsigned char *pc;
    struct timespec t;
    t.tv_sec = 0;
    t.tv_nsec = 1;
    pc = buffer;
    if (parport_debug)
        fprintf(stderr, "\nsend:\n%04x: ",0);
    for (i=0; i<len; i++){
        timeout=8000;
        if (parport_debug) {
            fprintf(stderr, "%02x ",(unsigned char)*pc);
            if (!((i+1)%32) && i && i<len-1)
                fprintf(stderr, "\n%04x: ",i+1);
        }
       
        outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x04);
        parport_nop ();
        while ((inportb ((unsigned short) (f2a_pport + PARPORT_STATUS)) & PARPORT_IBUSY) && (timeout--) > 0)
            nanosleep(&t,NULL);
        
        outportb ((unsigned short) (f2a_pport + PARPORT_DATA), *pc);
        parport_nop ();
        while ((inportb ((unsigned short) (f2a_pport + PARPORT_STATUS)) & PARPORT_IBUSY) && (timeout--) > 0)
           nanosleep(&t,NULL);
        
        outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x05);
        parport_nop ();
        while ((!(inportb ((unsigned short) (f2a_pport + PARPORT_STATUS)) & PARPORT_IBUSY)) && (timeout--) > 0)
           nanosleep(&t,NULL);
        pc++;
        if (timeout<0){
            fprintf(stdout,"\nTimeout\n");
            return -1;
        }
    }
    if (parport_debug)
        fprintf(stderr,"\n");

    return 0;
}

static int parport_wait (void)
{    

    int stat;
    while (1){
       outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x04);
       parport_nop ();
       stat = inportb ((unsigned short) (f2a_pport + PARPORT_STATUS));
       if (stat & PARPORT_IBUSY)
            break;
       outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x05);
       parport_nop ();
       inportb ((unsigned short) (f2a_pport + PARPORT_STATUS));
    }
    return 0;
}



static unsigned int parport_flip(unsigned int val)
{
    return  	((((val&0xff) << 24)&0xff000000) |
                (((val&0xff00) << 8)&0xff0000) |
                (((val&0xff0000) >> 8)& 0xff00) |
                (((val&0xff000000) >> 24)&0xff));

}

static int  parport_init_delay(int target)
{
    struct timeval t0,t1;
    long diff;
    int loop,i,l;
    int hit,trials,cnt;
    int hits[10];
    int nop_cnt;
    trials = 1000;
    loop = 4000;
    hit=10;
    diff=0;
    cnt=0;
    while (cnt!=hit) {
        for (l=0;l<trials;l++){
            i = loop;
            gettimeofday(&t0,NULL);
            while(i--);
            gettimeofday(&t1,NULL);
            diff+=(t1.tv_usec - t0.tv_usec);
        }
        diff/=(trials/10);
        loop+=100;
    if (diff>=(target*10)){
            hits[cnt] = loop;
            cnt++;
        }
    }
    loop=0;
    for (i=0;i<hit;i++) loop+=hits[i];
    nop_cnt=loop/hit;

    return nop_cnt;
}




static void parport_nop ()
{
  volatile int i = parport_nop_cnt;
  while (i--);
}


static void parport_out31 (unsigned char val)
{
  outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x03);
  outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
  outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
  outportb ((unsigned short) (f2a_pport + PARPORT_DATA), val);
}


static void parport_out91 (unsigned char val)
{
  outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x09);
  outportb ((unsigned short) (f2a_pport + PARPORT_CONTROL), 0x01);
  outportb ((unsigned short) (f2a_pport + PARPORT_DATA), val);
}

void parport_close(void)
{
    if (PPDEV == f2a_mode) {
        ioctl (f2a_pport_fd, PPRELEASE);
    } 
}



unsigned char inportb (unsigned short port)
{
    if (PPDEV == f2a_mode) {
  
        int ppreg = port - f2a_pport;
        unsigned char byte;
        
        switch (ppreg)
            {
            case 0:                                     // data
            if (f2a_io_direction == FORWARD)       // dir is forward?
                {
                f2a_io_direction = REVERSE;        // change it to reverse
                ioctl (f2a_pport_fd, PPDATADIR, &f2a_io_direction);
                }
            ioctl (f2a_pport_fd, PPRDATA, &byte);
            break;
            case 1:                                     // status
            ioctl (f2a_pport_fd, PPRSTATUS, &byte);
            break;
            case 2:                                     // control
            ioctl (f2a_pport_fd, PPRCONTROL, &byte);
            break;
            case 3:                                     // EPP/ECP address
            if (!(f2a_io_mode & IEEE1284_ADDR))    // IEEE1284_DATA is 0!
                {
                f2a_io_mode |= IEEE1284_ADDR;
                ioctl (f2a_pport_fd, PPSETMODE, &f2a_io_mode);
                }
            read (f2a_pport_fd, &byte, 1);
            break;
            case 4:                                     // EPP/ECP data
            if (f2a_io_mode & IEEE1284_ADDR)
                {
                f2a_io_mode &= ~IEEE1284_ADDR;     // IEEE1284_DATA is 0
                ioctl (f2a_pport_fd, PPSETMODE, &f2a_io_mode);
                }
            read (f2a_pport_fd, &byte, 1);
            break;
            case 0x402:                                 // ECP register
            printf ("WARNING: Ignored read from ECP register, returning 0\n");
            byte = 0;
            break;
            default:
            fprintf (stderr,
                    "ERROR: inportb() tried to read from an unsupported port (0x%x)\n",
                    port);
            exit (1);
        }
        return byte;
    } else {
        return inb (port);
    }
}


void outportb (unsigned short port, unsigned char byte)
{
    if (PPDEV == f2a_mode){
        int ppreg = port - f2a_pport;
        switch (ppreg)
            {
            case 0:                                     // data
            if (f2a_io_direction == REVERSE)       // dir is reverse?
                {
                f2a_io_direction = FORWARD;        // change it to forward
                ioctl (f2a_pport_fd, PPDATADIR, &f2a_io_direction);
                }
            ioctl (f2a_pport_fd, PPWDATA, &byte);
            break;
            case 2:                                     // control
            ioctl (f2a_pport_fd, PPWCONTROL, &byte);
            break;
            case 3:                                     // EPP/ECP address
            if (!(f2a_io_mode & IEEE1284_ADDR))    // IEEE1284_DATA is 0!
                {
                f2a_io_mode |= IEEE1284_ADDR;
                ioctl (f2a_pport_fd, PPSETMODE, &f2a_io_mode);
                }
            write (f2a_pport_fd, &byte, 1);
            break;
            case 4:                                     // EPP/ECP data
            if (f2a_io_mode & IEEE1284_ADDR)
                {
                f2a_io_mode &= ~IEEE1284_ADDR;     // IEEE1284_DATA is 0
                ioctl (f2a_pport_fd, PPSETMODE, &f2a_io_mode);
                }
            write (f2a_pport_fd, &byte, 1);
            break;
            case 0x402:                                 // ECP register
            printf ("WARNING: Ignored write to ECP register\n");
            break;
            default:
            fprintf (stderr,
                    "ERROR: outportb() tried to write to an unsupported port (0x%x)\n",
                    port);
            exit (1);
            }
    } else {
      outb (byte, port);
    }
}




int parport_open (int port)
{
    if (PPDEV == f2a_mode) {
        struct timeval t;
        int capabilities = 0, x;
        
        if (port == PARPORT_UNKNOWN)
            port = 0;
        
        f2a_pport_fd = open (f2a_ppdev, O_RDWR | O_NONBLOCK);
        if (f2a_pport_fd == -1){
            fprintf (stderr, "ERROR: Could not open parallel port device (%s)\n"
                            "       Check if you have the required privileges\n",f2a_ppdev);
            exit (1);
        }
        if (ioctl (f2a_pport_fd, PPEXCL)){                 // disable sharing
            fprintf (stderr, "ERROR: PPEXCL failed (%s) (%s)\n",f2a_ppdev,strerror(errno));
            exit (1);
        }  
        if (ioctl (f2a_pport_fd, PPCLAIM)){
            fprintf (stderr, "ERROR: PPCLAIM failed (%s) (%s)\n",f2a_ppdev,strerror(errno));
            exit (1);
        }
        
        t.tv_sec = 0;
        t.tv_usec = 500 * 1000;                       // set time-out to 500 milliseconds
        ioctl (f2a_pport_fd, PPSETTIME, &t);
        
        ioctl (f2a_pport_fd, PPGETMODES, &capabilities);
        
        if ((capabilities & (PARPORT_MODE_EPP | PARPORT_MODE_ECP)) == 0)
            fprintf (stderr,"WARNING: EPP or ECP mode was requested, but not available\n");
        fprintf (stderr,"EPP or ECP mode was requested\n");
        
        if (capabilities & PARPORT_MODE_ECP)
            f2a_io_mode = IEEE1284_MODE_ECP;
        else if (capabilities & PARPORT_MODE_EPP)
            f2a_io_mode = IEEE1284_MODE_EPP;
        else
            f2a_io_mode = IEEE1284_MODE_BYTE;
        f2a_io_mode |= IEEE1284_DATA;                  // default to EPP/ECP data reg
        ioctl (f2a_pport_fd, PPSETMODE, &f2a_io_mode); //  (IEEE1284_DATA is 0...)
        
        x = PP_FASTREAD | PP_FASTWRITE;
        ioctl (f2a_pport_fd, PPSETFLAGS, &x);         // enable 16-bit transfers
        
        f2a_io_direction = FORWARD;                // set forward direction as default
        ioctl (f2a_pport_fd, PPDATADIR, &f2a_io_direction);
    
    }else {
        
        if(ioperm((f2a_pport + PARPORT_DATA), 3, 1)){
            fprintf (stderr, "ERROR: ioperm failed\n");
            return -1;
        }
       if(iopl(3)){
            fprintf (stderr, "ERROR: iopl failed\n");
            return -1;
        }
    
        if (getgid () && !getegid ())
            setegid (getgid ());
    
        if (getuid () && !geteuid ())
            seteuid (getuid ());
     }
      outportb ((unsigned short) (port + PARPORT_CONTROL),
            (unsigned char) (inportb ((unsigned short) (port + PARPORT_CONTROL)) & 0x0f));
      // bit 4 = 0 -> IRQ disable for ACK, bit 5-7 unused
    return port;
}



