// (C) 2003 Ulrich Hecht <uli@emulinks.de>
// Licensed under the terms of the GNU Public License version 2

#include "f2a.h"
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>

int f2a_writemem(int numfiles, char** files, int address)
{
	sendmsg sm;

	int i,j;
	int romf;
	unsigned char rom[1024];
	struct stat st;
	
	memset(&sm, 0, sizeof(sm));

	// initialize command buffer
	sm.command=CMD_WRITEDATA;
	sm.magic=MAGIC_NUMBER;
	sm.unknown=0xa;		// no idea what this is...
	
	for(j=0; j<numfiles; j++)
	{
		if(verbose) printf("sending file %d: %s\n", j, files[j]);
		
		if(stat(files[j],&st)==-1)
		{
			perror("failed to stat file");
			return -1;
		}

		// round up to 32k, FIXME: This has to be 128k for Turbo carts
		if(st.st_size & (32768-1)) st.st_size+=32768;
		st.st_size&=~(32768-1);

		romf=open(files[j],O_RDONLY);

		// flash the ROM
		sm.size=st.st_size;
		sm.address=address;
		sm.sizekb=st.st_size/1024;

		if(sendf2a(sm)==-1) return -1;

		for(i=0;i<st.st_size;i+=1024)
		{
			//printf("writing chunk %d\n", i);
			if(read(romf, rom, 1024)==-1)
			{
				perror("failed to read from file");
				return -1;
			}
			if(usb_write(rom,1024)==-1) return -1;
		}

		close(romf);
		address+=st.st_size;
	}

	return 0;
}
